--AH:ScriptId=5aff92e7-0f18-44e7-b7de-cc5b6933513a;3009
ALTER TABLE [BuildArtifacts]
	DROP CONSTRAINT [FK__BuildArtifacts__Builds]
ALTER TABLE [BuildArtifacts]
	ADD [Build_Id] INT NULL

ALTER TABLE [BuildPromotions]
	DROP CONSTRAINT [FK__BuildPromotions__Builds]
ALTER TABLE [BuildPromotions]
	ADD [Build_Id] INT NULL

ALTER TABLE [BuildExecutions]
	DROP CONSTRAINT [FK__BuildExecutions__Builds]

ALTER TABLE [BuildApprovalsReceived]
	DROP CONSTRAINT [FK__BuildApprovalsReceived__Builds]
ALTER TABLE [BuildApprovalsReceived]
	ADD [Build_Id] INT NULL
ALTER TABLE [BuildApprovalsReceived]
	ADD [PipelineStage_Name] VARCHAR(50) NULL

ALTER TABLE [PromotionRequirementStatuses]
	DROP CONSTRAINT [FK__PromotionRequirementStatuses__Builds]
ALTER TABLE [PromotionRequirementStatuses]
	ADD [Build_Id] INT NULL
ALTER TABLE [PromotionRequirementStatuses]
	ADD [PipelineStage_Name] VARCHAR(50) NULL

ALTER TABLE [BuildPromotionsScheduled]
	DROP CONSTRAINT [FK__BuildPromotionsScheduled__Builds]
ALTER TABLE [BuildPromotionsScheduled]
	ADD [Build_Id] INT NULL
ALTER TABLE [BuildPromotionsScheduled]
	ADD [PipelineStage_Name] VARCHAR(50) NULL

ALTER TABLE [VariableDefinitions]
	ADD [Build_Id] INT NULL

ALTER TABLE [Builds]
	ADD [Build_Id] INT IDENTITY(1, 1) NOT NULL

ALTER TABLE [Builds]
	ADD [Furthest_PipelineStage_Name] VARCHAR(50) NULL

GO

UPDATE BA
   SET BA.[Build_Id] = B.[Build_Id]
  FROM [BuildArtifacts] BA
       INNER JOIN [Builds] B
	           ON B.[Application_Id] = BA.[Application_Id]
			  AND B.[Release_Number] = BA.[Release_Number]
			  AND B.[Build_Number] = BA.[Build_Number]

UPDATE BP
   SET BP.[Build_Id] = B.[Build_Id]
  FROM [BuildPromotions] BP
       INNER JOIN [Builds] B
	           ON B.[Application_Id] = BP.[Application_Id]
			  AND B.[Release_Number] = BP.[Release_Number]
			  AND B.[Build_Number] = BP.[Build_Number]

UPDATE BAR
   SET BAR.[Build_Id] = B.[Build_Id],
       BAR.[PipelineStage_Name] = E.[Environment_Name]
  FROM [BuildApprovalsReceived] BAR
       INNER JOIN [Builds] B
	           ON B.[Application_Id] = BAR.[Application_Id]
			  AND B.[Release_Number] = BAR.[Release_Number]
			  AND B.[Build_Number] = BAR.[Build_Number]
	   INNER JOIN [Environments] E
	           ON E.[Environment_Id] = BAR.[Environment_Id]

UPDATE PRS
   SET PRS.[Build_Id] = B.[Build_Id],
	   PRS.[PipelineStage_Name] = E.[Environment_Name]
  FROM [PromotionRequirementStatuses] PRS
       INNER JOIN [Builds] B
	           ON B.[Application_Id] = PRS.[Application_Id]
			  AND B.[Release_Number] = PRS.[Release_Number]
			  AND B.[Build_Number] = PRS.[Build_Number]
	   INNER JOIN [Environments] E
	           ON E.[Environment_Id] = PRS.[Environment_Id]

UPDATE BPS
   SET BPS.[Build_Id] = B.[Build_Id],
       BPS.[PipelineStage_Name] = E.[Environment_Name]
  FROM [BuildPromotionsScheduled] BPS
       INNER JOIN [Builds] B
	           ON B.[Application_Id] = BPS.[Application_Id]
			  AND B.[Release_Number] = BPS.[Release_Number]
			  AND B.[Build_Number] = BPS.[Build_Number]
	   INNER JOIN [Environments] E
	           ON E.[Environment_Id] = BPS.[Environment_Id]

UPDATE B
   SET B.[Furthest_PipelineStage_Name] = (SELECT TOP 1 E.[Environment_Name]
                                            FROM [WorkflowSteps] WS
											     INNER JOIN [Environments] E
												         ON E.[Environment_Id] = WS.[Environment_Id]
										   WHERE WS.[Workflow_Id] = R.[Workflow_Id]
										   ORDER BY WS.[Step_Sequence] DESC)
  FROM [Builds] B
       INNER JOIN [Releases] R
	           ON R.[Release_Id] = B.[Release_Id]

ALTER TABLE [Builds]
	DROP CONSTRAINT [PK__Builds]

ALTER TABLE [Builds]
	ADD CONSTRAINT [PK__Builds]
		PRIMARY KEY ([Build_Id])

ALTER TABLE [Builds]
	ADD CONSTRAINT [UQ__Builds]
		UNIQUE ([Release_Id], [Build_Number])
GO

ALTER TABLE [BuildArtifacts]
	ALTER COLUMN [Build_Id] INT NOT NULL
ALTER TABLE [BuildArtifacts]
	DROP CONSTRAINT [PK__BuildArtifacts]
ALTER TABLE [BuildArtifacts]
	DROP COLUMN [Application_Id]
ALTER TABLE [BuildArtifacts]
	DROP COLUMN [Release_Number]
ALTER TABLE [BuildArtifacts]
	DROP COLUMN [Build_Number]
ALTER TABLE [BuildArtifacts]
	ADD CONSTRAINT [PK__BuildArtifacts]
		PRIMARY KEY ([Build_Id], [Artifact_Name])
ALTER TABLE [BuildArtifacts]
	ADD CONSTRAINT [FK__BuildArtifacts__Builds]
		FOREIGN KEY ([Build_Id])
		REFERENCES [Builds] ([Build_Id])

ALTER TABLE [BuildPromotions]
	ALTER COLUMN [Build_Id] INT NOT NULL
ALTER TABLE [BuildPromotions]
	ADD CONSTRAINT [FK__BuildPromotions__Builds]
		FOREIGN KEY ([Build_Id])
		REFERENCES [Builds] ([Build_Id])
		ON DELETE CASCADE

ALTER TABLE [BuildApprovalsReceived]
	DROP CONSTRAINT [FK__BuildApprovalsReceived__Environments]
ALTER TABLE [BuildApprovalsReceived]
	ALTER COLUMN [Build_Id] INT NOT NULL
ALTER TABLE [BuildApprovalsReceived]
	ALTER COLUMN [PipelineStage_Name] VARCHAR(50) NOT NULL
ALTER TABLE [BuildApprovalsReceived]
	ADD CONSTRAINT [FK__BuildApprovalsReceived__Builds]
		FOREIGN KEY ([Build_Id])
		REFERENCES [Builds] ([Build_Id])
		ON DELETE CASCADE
ALTER TABLE [BuildApprovalsReceived]
	DROP COLUMN [Application_Id]
ALTER TABLE [BuildApprovalsReceived]
	DROP COLUMN [Release_Number]
ALTER TABLE [BuildApprovalsReceived]
	DROP COLUMN [Build_Number]
ALTER TABLE [BuildApprovalsReceived]
	DROP COLUMN [Environment_Id]

ALTER TABLE [PromotionRequirementStatuses]
	ALTER COLUMN [Build_Id] INT NOT NULL
ALTER TABLE [PromotionRequirementStatuses]
	ALTER COLUMN [PipelineStage_Name] VARCHAR(50) NOT NULL
ALTER TABLE [PromotionRequirementStatuses]
	ADD CONSTRAINT [FK__PromotionRequirementStatuses__Builds]
		FOREIGN KEY ([Build_Id])
		REFERENCES [Builds] ([Build_Id])
		ON DELETE CASCADE
ALTER TABLE [PromotionRequirementStatuses]
	DROP CONSTRAINT [UQ__PromotionRequirementStatus]
ALTER TABLE [PromotionRequirementStatuses]
	DROP COLUMN [Application_Id]
ALTER TABLE [PromotionRequirementStatuses]
	DROP COLUMN [Release_Number]
ALTER TABLE [PromotionRequirementStatuses]
	DROP COLUMN [Build_Number]
ALTER TABLE [PromotionRequirementStatuses]
	DROP COLUMN [Environment_Id]
ALTER TABLE [PromotionRequirementStatuses]
	ADD CONSTRAINT [UQ__PromotionRequirementStatuses]
		UNIQUE ([Build_Id], [PipelineStage_Name], [PromotionRequirement_Sequence])

ALTER TABLE [BuildPromotionsScheduled]
	DROP CONSTRAINT [FK__BuildPromotionsScheduled__Environments]
ALTER TABLE [BuildPromotionsScheduled]
	ALTER COLUMN [Build_Id] INT NOT NULL
ALTER TABLE [BuildPromotionsScheduled]
	ALTER COLUMN [PipelineStage_Name] VARCHAR(50) NOT NULL
ALTER TABLE [BuildPromotionsScheduled]
	ADD CONSTRAINT [FK__BuildPromotionsScheduled__Builds]
		FOREIGN KEY ([Build_Id])
		REFERENCES [Builds] ([Build_Id])
		ON DELETE CASCADE
ALTER TABLE [BuildPromotionsScheduled]
	DROP CONSTRAINT [PK__BuildPromotionsScheduled]
ALTER TABLE [BuildPromotionsScheduled]
	DROP COLUMN [Application_Id]
ALTER TABLE [BuildPromotionsScheduled]
	DROP COLUMN [Release_Number]
ALTER TABLE [BuildPromotionsScheduled]
	DROP COLUMN [Build_Number]
ALTER TABLE [BuildPromotionsScheduled]
	DROP COLUMN [Environment_Id]
ALTER TABLE [BuildPromotionsScheduled]
	ADD CONSTRAINT [PK__BuildPromotionsScheduled]
		PRIMARY KEY ([Build_Id], [PipelineStage_Name])

ALTER TABLE [VariableDefinitions]
	ADD CONSTRAINT [FK__VariableDefinitions__Builds]
		FOREIGN KEY ([Build_Id])
		REFERENCES [Builds] ([Build_Id])
