--AH:ScriptId=162894C6-7351-44CB-BF22-4F69C8CE008C

IF OBJECT_ID('[BuildTestResults_AllGroups]') IS NOT NULL DROP VIEW [BuildTestResults_AllGroups]
GO

ALTER TABLE [BuildTestResults]
	DROP CONSTRAINT [PK__BuildTestResults]

ALTER TABLE [BuildTestResults]
	ALTER COLUMN [Group_Name] NVARCHAR(50) NOT NULL

ALTER TABLE [BuildTestResults]
	ADD CONSTRAINT [PK__BuildTestResults]
		PRIMARY KEY ([Execution_Id], [Group_Name], [Test_Sequence])

ALTER TABLE [BuildTestResults]
	ALTER COLUMN [Test_Name] NVARCHAR(255) NOT NULL

ALTER TABLE [BuildTestResults]
	ALTER COLUMN [TestResult_Text] NVARCHAR(MAX) NOT NULL

ALTER TABLE [BuildTestResults]
	ADD [TestDuration_Milliseconds] BIGINT

GO

UPDATE [BuildTestResults]
   -- not using DATEDIFF_BIG because it wasn't introduced until SQL 2016
   SET [TestDuration_Milliseconds] = CASE WHEN DATEDIFF(day, [TestStarted_Date], [TestEnded_Date]) < 24 THEN CAST(DATEDIFF(ms, [TestStarted_Date], [TestEnded_Date]) AS BIGINT) ELSE CAST(DATEDIFF(s, [TestStarted_Date], [TestEnded_Date]) AS BIGINT) * 1000 END
GO

ALTER TABLE [BuildTestResults]
	ALTER COLUMN [TestDuration_Milliseconds] BIGINT NOT NULL

ALTER TABLE [BuildTestResults]
	DROP COLUMN [TestEnded_Date]
