EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Promotions_InvalidateApprovals',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes received approvals for a pending promotion.'
GO

IF OBJECT_ID('[Promotions_InvalidateApprovals]') IS NOT NULL DROP PROCEDURE [Promotions_InvalidateApprovals]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Promotions_InvalidateApprovals]
(
	@Pipeline_Name VARCHAR(100),
	@PipelineStage_Name VARCHAR(50)
) AS BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

    DELETE BAR
      FROM [BuildApprovalsReceived] BAR
     INNER JOIN [Builds] B ON B.[Build_Id] = BAR.[Build_Id]
     INNER JOIN [Releases] R ON R.[Release_Id] = B.[Release_Id]
     LEFT JOIN [BuildPromotions] P 
            ON P.[Build_Id] = BAR.[Build_Id] 
           AND P.[PipelineStage_Name] = BAR.[PipelineStage_Name]
    WHERE P.[Promotion_Id] IS NULL
      AND R.[Pipeline_Name] = @Pipeline_Name
      AND BAR.[PipelineStage_Name] = @PipelineStage_Name

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Promotions_InvalidateApprovals] TO [BuildMasterUser_Role]