EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'BuildTestResults_GetTestGroupResultsForApplication',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'BuildTestResults_TestGroupResults',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the unit test results for the specified application.'
GO

IF OBJECT_ID('[BuildTestResults_GetTestGroupResultsForApplication]') IS NOT NULL DROP PROCEDURE [BuildTestResults_GetTestGroupResultsForApplication]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [BuildTestResults_GetTestGroupResultsForApplication]
(
	@Application_Id INT,
    @Release_Number RELEASENUMBER = NULL,
    @Build_Number BUILDNUMBER = NULL,
	@Group_Name NVARCHAR(255) = NULL,
	@Row_Count INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	IF @Row_Count IS NOT NULL
		SET ROWCOUNT @Row_Count

	SELECT *
	  FROM [BuildTestResults_TestGroupResults]
	 WHERE [Application_Id] = @Application_Id
	   AND (@Release_Number IS NULL OR [Release_Number] = @Release_Number)
	   AND (@Build_Number IS NULL OR [Build_Number] = @Build_Number)
	   AND (@Group_Name IS NULL OR [Group_Name] = @Group_Name)
	 ORDER BY [Execution_Id] DESC

END
GO

GRANT EXECUTE ON [BuildTestResults_GetTestGroupResultsForApplication] TO [BuildMasterUser_Role]