EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Releases_GetReleaseDeployables',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'ReleaseDeployables_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the set of deployables associated with any release for an application.'
GO


IF OBJECT_ID('[Releases_GetReleaseDeployables]') IS NOT NULL DROP PROCEDURE [Releases_GetReleaseDeployables]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Releases_GetReleaseDeployables]
(
	@Application_Id INT = NULL,
	@Release_Id INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [ReleaseDeployables_Extended]
	 WHERE @Application_Id IS NULL OR [Application_Id] = @Application_Id
	   AND @Release_Id IS NULL OR [Release_Id] = @Release_Id
END
GO

GRANT EXECUTE ON [Releases_GetReleaseDeployables] TO [BuildMasterUser_Role]
