EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Security_GetNamedUser',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'NamedUsers',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the specified named user'
GO

IF OBJECT_ID('[Security_GetNamedUser]') IS NOT NULL DROP PROCEDURE [Security_GetNamedUser]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Security_GetNamedUser]
(
    @User_Name USERNAME,
	@SetLastAccessed_Indicator YNINDICATOR = 'N'
)
AS
BEGIN

	SET NOCOUNT ON

	IF @SetLastAccessed_Indicator = 'Y'
	BEGIN
		UPDATE [NamedUsers]
		SET [LastAccessed_Date] = GETUTCDATE()
		WHERE [User_Name] = @User_Name
	END

	SELECT * FROM [NamedUsers]
	WHERE [User_Name] = @User_Name


END
GO

GRANT EXECUTE ON [Security_GetNamedUser] TO [BuildMasterUser_Role]