EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'SetupTemplates_CreateOrUpdateSetupTemplate',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'SetupTemplate_Id',
    /* Description_Text        */ 'Creates a new setup template or updates an existing one.'
GO

IF OBJECT_ID('[SetupTemplates_CreateOrUpdateSetupTemplate]') IS NOT NULL DROP PROCEDURE [SetupTemplates_CreateOrUpdateSetupTemplate]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [SetupTemplates_CreateOrUpdateSetupTemplate]
(
	@SetupTemplate_Name VARCHAR(200),
	@SetupTemplate_Configuration XML,
	@Active_Indicator YNINDICATOR,
	@SetupTemplate_Id INT = NULL OUT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	IF @SetupTemplate_Id IS NULL
	BEGIN

		INSERT INTO [SetupTemplates]
		(
			[SetupTemplate_Name],
			[SetupTemplate_Configuration],
			[Active_Indicator]
		)
		VALUES
		(
			@SetupTemplate_Name,
			@SetupTemplate_Configuration,
            @Active_Indicator
		)

		SET @SetupTemplate_Id = SCOPE_IDENTITY()

	END
	ELSE
	BEGIN

		UPDATE [SetupTemplates]
		   SET [SetupTemplate_Name] = @SetupTemplate_Name,
			   [SetupTemplate_Configuration] = @SetupTemplate_Configuration,
			   [Active_Indicator] = @Active_Indicator
		 WHERE [SetupTemplate_Id] = @SetupTemplate_Id

	END

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH


END
GO

GRANT EXECUTE ON [SetupTemplates_CreateOrUpdateSetupTemplate] TO [BuildMasterUser_Role]